-- Gamestates and Controls

gamestates = { }

gamestates.menu = {
  bindings = {
    down = function() mms.cycleChoice("down") end,
    up = function() mms.cycleChoice("up") end,
    game = function() print('Back to game') state = gamestates.game mms.destroyMsg("asafe") end,
    back = function() mms.backChoice() end,
    act = function() mms.activateChoice() end
  },
  keys = {
    down = "down",
    up = "up",
    x = "back",
    z = "act"
  },
  keysreleased = { },
  buttons = {
    
  },
  buttonsreleased = { }
}

gamestates.game = {
  bindings = {
    left = function() char_obj.move("player", 'left') end,
    right = function() char_obj.move("player", 'right') end,
    up = function() char_obj.move("player", 'up') end,
    down = function() char_obj.move("player", 'down') end,
    left_r = function() char_obj.stop("player", 'left') end,
    right_r = function() char_obj.stop("player", 'right') end,
    up_r = function() char_obj.stop("player", 'up') end,
    down_r = function() char_obj.stop("player", 'down') end,
    action = function() if not wait then char_obj.act() end end,
    menu = function() mms.destroyMsg(conw) mms.openIGM() end,
    debugger = function() debugging = not debugging collectgarbage() end,
    q = le.quit
  },
  keys = {
    left = "left",
    right = "right",
    up = "up",
    down = "down",
	  x = "menu",
    y = "map",
    z = "action",
    lctrl = "noclip",
    c = "debugger",
    escape = "q"
  },
  keysreleased = {
    left = "left_r",
    right = "right_r",
    up = "up_r",
    down = "down_r"
  },
  buttons = {
    
  },
  buttonsreleased = { }
}

gamestates.msg = {
  bindings = {
    left = function() end,
    right = function() end,
    up = function() end,
    down = function() end,
    left_r = function() end,
    right_r = function() end,
    up_r = function() end,
    down_r = function() end,
    action = function() if mevoq == nil then mms.destroyMsg("all") wait = false state = gamestates.game else maps.actdata[mevoq]() end end,
    debugger = function() debugging = not debugging end,
    q = le.quit
  },
  keys = {
    left = "left",
    right = "right",
    up = "up",
    down = "down",
	  x = "menu",
    y = "map",
    z = "action",
    lctrl = "noclip",
    c = "debugger",
    escape = "q"
  },
  keysreleased = {
    left = "left_r",
    right = "right_r",
    up = "up_r",
    down = "down_r"
  },
  buttons = {
    
  },
  buttonsreleased = { }
}

gamestates.card_game = {
  bindings = {
    down = function() mms.cycleChoice("down") end,
    up = function() mms.cycleChoice("up") end,
    left = function() mms.cycleChoice("left") end,
    right = function() mms.cycleChoice("right") end,
    game = function() print('Back to game') state = gamestates.game mms.destroyMsg("asafe") end,
    back = function() mms.backChoice() end,
    act = function() mms.activateChoice() end
  },
  keys = {
    down = "down",
    up = "up",
    right = "right",
    left = "left",
    x = "back",
    z = "act"
  },
  keysreleased = { },
  buttons = {
    
  },
  buttonsreleased = { }
}

state = gamestates.game

function inputHandler(input)
  local action = state.bindings[input]
  if action then return action() end
end

local mousefilter = function(item, other)
  if other.mouseable then return 'cross' end
end

function love.mousemoved(x, y, dx, dy)
  if not debugging then return end
  local mx, my, mcols, mcols_len = world:move(mouseblock, x - tx, y - ty, mousefilter)
  for i, b in pairs(blocks) do
    if not b.wall then
      b.color = {0, 255, 0, 0}
    else
      b.color = {255, 0, 0, 255}
    end
  end
  for i = 1, mcols_len do
    local other = mcols[i].other
    if other.mouseable then other.color = {0, 255, 0, 255} end
    if mbdown == 1 and other.mouseable then other.wall = true end
    if mbdown == 2 and other.mouseable and other.wall then other.wall = false end
  end
end

function love.mousepressed(x, y, button, istouch)
  if istouch then return end
  if not debugging then return end
  mbdown = button
  local mx, my, mcols, mlen = world:move(mouseblock, x - tx, y - ty, mousefilter)
  for i = 1, mlen do
    local other = mcols[i].other
    if button == 1 and other.mouseable then other.wall = true end
    if button == 2 and other.mouseable and other.wall then other.wall = false end
  end
end

function love.mousereleased(x, y, button, istouch)
  if istouch then return end
  if not debugging then return end
  mbdown = nil
end

function love.touchmoved(id, x, y, dx, dy, pressure)
  if not (mobile or touchCon) then return end
  local binding
  if moving_id == id and x > 114 and x < 174 and y > winH - 210 and y < winH - 160 then binding = state.keys["up"] end
  if moving_id == id and x > 114 and x < 174 and y > winH - 100 and y < winH - 50 then binding = state.keys["down"] end
  if moving_id == id and x > 64 and x < 140 and y > winH - 160 and y < winH - 100 then binding = state.keys["left"] end
  if moving_id == id and x > 148 and x < 234 and y > winH - 160 and y < winH - 100 then binding = state.keys["right"] end
  return inputHandler(binding)
end

function love.touchpressed(id, x, y, dx, dy, pressure)
  if not (mobile or touchCon) then return end
  inputMethod = "touch"
  local binding
  if x > 114 and x < 174 and y > winH - 210 and y < winH - 160 then moving_id = id binding = state.keys["up"] end
  if x > 114 and x < 174 and y > winH - 100 and y < winH - 50 then moving_id = id binding = state.keys["down"] end
  if x > 64 and x < 140 and y > winH - 160 and y < winH - 100 then moving_id = id binding = state.keys["left"] end
  if x > 148 and x < 234 and y > winH - 160 and y < winH - 100 then moving_id = id binding = state.keys["right"] end
  return inputHandler(binding)
end

function love.touchreleased(id, x, y, dx, dy, pressure)
  if not (mobile or touchCon) then return end
  local binding
  if x > 114 and x < 174 and y > winH - 210 and y < winH - 160 then binding = state.keysreleased["up"] end
  if x > 114 and x < 174 and y > winH - 100 and y < winH - 50 then binding = state.keysreleased["down"] end
  if x > 64 and x < 140 and y > winH - 160 and y < winH - 100 then binding = state.keysreleased["left"] end
  if x > 148 and x < 234 and y > winH - 160 and y < winH - 100 then binding = state.keysreleased["right"] end
  if x > winW - 160 and x < winW - 80 and y > winH - 240 and y < winH - 160 then binding = state.keys["x"] end
  if x > winW - 240 and x < winW - 160 and y > winH - 160 and y < winH - 80 then binding = state.keys["z"] end
  return inputHandler(binding)
end

function love.keypressed(key)
  inputMethod = "keyboard"
  local binding = state.keys[key]
  return inputHandler(binding)
end

function love.keyreleased(key)
  local binding = state.keysreleased[key]
  return inputHandler(binding)
end

function love.gamepadpressed(js, button)
  inputMethod = "gamepad"
  local binding = state.buttons[button]
  return inputHandler(binding)
end

function love.gamepadreleased(js, button)
  local binding = state.buttons[button]
  return inputHandler(binding)
end