-- Map Handling

maps = { }

function maps.moveTo(name, px, py, pf)
  if px == nil then
    px, py = 2, 2
  end
  for i, c in pairs(chars) do
    world:remove(c)
  end
  if mapName ~= nil then
    if pf == nil and chars["player"] ~= nil then pf = chars["player"].facing end
    chars = { }
  end
  maps.actdata = { }
  maps.updatedata = { }
  mapName = name
  local ok, chunk
  if lfs.exists('assets/maps/'..mapName..'_mad.lua') then
    ok, chunk = pcall(lfs.load, 'assets/maps/'..mapName..'_mad.lua')
  end
  if chunk ~= nil then
    pcall(chunk)
  end
  world = bump.newWorld(16)
  if lfs.exists(mapName.."/chars.obj") then
    local dat = Tserial.unpack(lfs.read(mapName.."/chars.obj"))
    for i, c in pairs(dat) do
      char_obj.new(c[1], c[2], c[3], c[4], c[5], c[6])
      print("Created "..c[1].." object...")
    end
  end
  map = sti.new("assets/maps/"..mapName..".lua", { "bump" })
  if map.properties.noplayer then noplayer = true else noplayer = false end
  objtable = map.objects
  charLayer = map:convertToCustomLayer("Char")
  if not noplayer then char_obj.new({name = "player", x = (px * 32), y = (py * 32), properties = { sprite = 'fSoldier01' }}) end
  for i, o in pairs(objtable) do
    if o.type == "" or o.type == "char" then
      print(o.x)
      char_obj.new(o)
    elseif o.type == "floor" then
      floor_obj.new(o)
    elseif map.properties.cardfield and o.type == "card" then
      card_obj.new(o)
    end
  end
  function charLayer:draw()
    char_obj.draw()
  end
  map:bump_init(world)
  if chars["player"] ~= nil then chars["player"].facing = (pf or "down") end
  --if map.properties.edges ~= nil then maps.edges = Tserial.unpack(map.properties.edges) maps.setedges() end
  if maps.actdata ~= nil and maps.actdata["load"] ~= nil then maps.actdata["load"]() end
end

function maps.savesnap()
  
end

function maps.loadedges()
  lfs.createDirectory("assets/maps/edges")
  local mes = lfs.getDirectoryItems("assets/maps/")
  for i, m in pairs(mes) do
    if string.sub(m, -3, -1) == "lua" and string.sub(m, -7, -1) ~= "mad.lua" then
      local scrim = sti.new("assets/maps/"..m, { })
      scrim:convertToCustomLayer("Char")
      local scr = lg.newCanvas(scrim.width * 32, scrim.height * 32)
      lg.setCanvas(scr)
      scrim:resize(scrim.width * 32, scrim.height * 32)
      scrim:draw()
      lg.setCanvas()
      local scrimdat = scr:newImageData()
      scrimdat:encode("png", "assets/maps/edges/"..string.sub(m, 1, -4).."png")
    end
  end
end

function maps.setedges()
  edgemaps = { }
  collectgarbage()
  for i, m in pairs(maps.edges) do
    local mei = {lg.newImage("assets/maps/edges/"..m.m..".png"), m.x, m.y}
    table.insert(edgemaps, mei)
  end
end

function maps.drawedges()
  if edgemaps == nil then return end
  for i, m in pairs(edgemaps) do
    lg.draw(m[1], m[2] * 32, m[3] * 32)
  end
end

--[[function maps.loadedges()
  edgemaps = { }
  for i, m in pairs(maps.edges) do
    local mape = {sti.new("assets/maps/"..m.m..".lua", { "bump" }), m.x, m.y}
    mape[1]:resize(lg.getWidth(), lg.getHeight())
    mape[1]:convertToCustomLayer("Char")
    table.insert(edgemaps, mape)
  end
end

function maps.drawedges()
  lg.setBackgroundColor(0, 0, 0, 0)
  if edgemaps == nil then return end
  for i, m in pairs(edgemaps) do
    lg.push()
    lg.translate(m[2] * 32, m[3] * 32)
    m[1]:draw()
    lg.pop()
  end
end]]
