-- Messages and Menus

mms = { }
messages = { }
menus = { }
mms.up = { }
mms.choice = 1
warr = { }
warr.o = 8
warr.w = 0
warr.c = 1
warr[1] = lg.newImage("assets/window/arrow2.png")
warr[2] = lg.newImage("assets/window/arrow.png")
win = { }
win.img = {
  lg.newImage("assets/window/win2.png"),
  lg.newImage("assets/window/win.png")
}
win.tl = lg.newQuad(0, 0, 32, 32, 96, 96)
win.t = lg.newQuad(32, 0, 32, 32, 96, 96)
win.tr = lg.newQuad(64, 0, 32, 32, 96, 96)
win.r = lg.newQuad(64, 32, 32, 32, 96, 96)
win.br = lg.newQuad(64, 64, 32, 32, 96, 96)
win.b = lg.newQuad(32, 64, 32, 32, 96, 96)
win.bl = lg.newQuad(0, 64, 32, 32, 96, 96)
win.l = lg.newQuad(0, 32, 32, 32, 96, 96)
win.bk = lg.newQuad(32, 32, 32, 32, 96, 96)

font = {
  lg.newFont("assets/fonts/werdnasreturn/WerdnasReturn.ttf", 22),
  lg.newFont("assets/fonts/pixel_love/pixel-love.ttf", 16),
}

function mms.createMsg(msgt)
  local wwW = lg.getWidth()
  if gbamode then wwW = 480 end
  local text = msgt
  if text.font == nil then text.font = 1 end
  text.txt = lg.newText(font[text.font], msgt.msg)
  local txtx, txty = text.txt:getDimensions()
  if text.y == "bottom" then text.y = winH - txty - 48 end
  if text.y == "top" then text.y = 16 end
  if text.x == "right" then text.x = winW - txtx - 28 end
  if text.x == "left" then text.x = 16 end
  if text.x == nil and txtx < (wwW - 56) and gbamode then text.x = winW / 2 - txtx / 2 + 28
  elseif text.x == nil and txtx < (wwW - 56) and not gbamode then text.x = winW / 2 - txtx / 2
  elseif text.x == nil then text.x = 28 end
  if text.y == nil then text.y = winH / 2 - txty / 2 end
  if text.oy then text.y = text.y + text.oy end
  if text.ox then text.x = text.x + text.ox end
  if msgt.win == nil then
    text.win = 1
  end
  if msgt.follow then
    text.txt:setf(msgt.msg, (msgt.ww or (wwW - 28 - msgt.x)), (msgt.align or "left"))
  else
    text.txt:setf(msgt.msg, (msgt.ww or 448), (msgt.align or "left"))
  end
  table.insert(messages, text)
  return #messages
end

function mms.destroyMsg(ind, r)
  if ind ~= nil then
    if type(ind) == "number" then
      table.remove(messages, ind)
    elseif ind == "all" then
      local msaver = { }
      for i, m in pairs(messages) do
        if m.save then table.insert(msaver, m) end
      end
      messages = msaver
      msaver = nil
    elseif ind == "asafe" then
      while #messages > 0 do
        table.remove(messages, #messages)
      end
    end
  else
    table.remove(messages, #messages)
  end
end

function mms.createMenu(msgt)
  mms.choice = 1
  local wwW = lg.getWidth()
  if gbamode then wwW = 480 end
  local text = msgt
  text.noarrow = true
  text.follow = true
  if text.font == nil then text.font = 1 end
  text.txt = lg.newText(font[text.font], msgt.msg)
  local txtx, txty = text.txt:getDimensions()
  if text.y == "bottom" then text.y = winH - txty - 48 end
  if text.y == "top" then text.y = 16 end
  if text.x == "right" then text.x = winW - txtx - 28 end
  if text.x == "left" then text.x = 16 end
  if text.x == nil and txtx < (wwW - 56) and gbamode then text.x = winW / 2 - txtx / 2 + 28
  elseif text.x == nil and txtx < (wwW - 56) and not gbamode then text.x = winW / 2 - txtx / 2
  elseif text.x == nil then text.x = 28 end
  if text.y == nil then text.y = winH / 2 - txty / 2 end
  if text.oy then text.y = text.y + text.oy end
  if text.ox then text.x = text.x + text.ox end
  if msgt.win == nil then
    text.win = 1
  end
  if msgt.follow then
    text.txt:setf(msgt.msg, (msgt.ww or (wwW - 28 - msgt.x)), (msgt.align or "left"))
  else
    text.txt:setf(msgt.msg, (msgt.ww or 448), (msgt.align or "left"))
  end
  table.insert(messages, text)
  return #messages
end

function mms.update(dt)
  if wait or state == gamestates.msg then
    warr.w = warr.w + warr.c * dt
    if warr.w <= 0 and warr.c == -1 then warr.c = -warr.c warr.o = warr.o + 2 end
    if warr.w >= 1 and warr.c == 1 then warr.c = -warr.c warr.o = warr.o - 2 end
  end
end

function mms.draw()
  for i, t in pairs(messages) do
    local txtx, txty = t.txt:getDimensions()
    if not t.follow then
      lg.draw(win.img[t.win], win.tl, t.x - 12, t.y - 8)
      lg.draw(win.img[t.win], win.t, t.x + 20, t.y - 8, 0, (txtx - 28)/32, 1)
      lg.draw(win.img[t.win], win.tr, t.x + 96 * ((txtx - 8)/96), t.y - 8)
      lg.draw(win.img[t.win], win.r, t.x + 96 * ((txtx - 8)/96), t.y + 24, 0, 1, (txty - 28)/32)
      lg.draw(win.img[t.win], win.br, t.x + 96 * ((txtx - 8)/96), t.y + 32 * ((txty - 28)/32) + 24)
      lg.draw(win.img[t.win], win.b, t.x + 20, t.y + 32 * ((txty - 28)/32) + 24, 0, (txtx - 28)/32, 1)
      lg.draw(win.img[t.win], win.bl, t.x - 12, t.y + 32 * ((txty - 28)/32) + 24)
      lg.draw(win.img[t.win], win.l, t.x - 12, t.y + 24, 0, 1, (txty - 28)/32)
      lg.draw(win.img[t.win], win.bk, t.x + 20, t.y + 24, 0, (txtx - 28)/32, (txty - 28)/32)
      lg.draw(t.txt, t.x, t.y + 4)
      if debugging then
        lg.rectangle('line', t.x, t.y, txtx, txty)
      end
      if (wait or state == gamestates.msg) and not t.noarrow then
        lg.draw(warr[t.win], t.x + txtx / 2 - 6, t.y + txty + warr.o)
      end
    end
  end
end

function mms.drawFollowing()
  for i, t in pairs(messages) do
    local txtx, txty = t.txt:getDimensions()
    if t.follow then
      lg.draw(win.img[t.win], win.tl, t.x - 12, t.y - 8)
      lg.draw(win.img[t.win], win.t, t.x + 20, t.y - 8, 0, (txtx - 28)/32, 1)
      lg.draw(win.img[t.win], win.tr, t.x + 96 * ((txtx - 8)/96), t.y - 8)
      lg.draw(win.img[t.win], win.r, t.x + 96 * ((txtx - 8)/96), t.y + 24, 0, 1, (txty - 28)/32)
      lg.draw(win.img[t.win], win.br, t.x + 96 * ((txtx - 8)/96), t.y + 32 * ((txty - 28)/32) + 24)
      lg.draw(win.img[t.win], win.b, t.x + 20, t.y + 32 * ((txty - 28)/32) + 24, 0, (txtx - 28)/32, 1)
      lg.draw(win.img[t.win], win.bl, t.x - 12, t.y + 32 * ((txty - 28)/32) + 24)
      lg.draw(win.img[t.win], win.l, t.x - 12, t.y + 24, 0, 1, (txty - 28)/32)
      lg.draw(win.img[t.win], win.bk, t.x + 20, t.y + 24, 0, (txtx - 28)/32, (txty - 28)/32)
      lg.draw(t.txt, t.x, t.y + 4)
      if debugging then
        lg.rectangle('line', t.x, t.y, txtx, txty)
      end
      if (wait or state == gamestates.msg) and not t.noarrow then
        lg.draw(warr[t.win], t.x + txtx / 2 - 6, t.y + txty + warr.o)
      end
      if state == gamestates.menu and activemenu == t.id then
        mms.choices = t.choices
        lg.rectangle('line', t.x, t.y + 4 + (font[t.font]:getHeight() * (mms.choice - 1)), txtx + 2, font[t.font]:getHeight())
      end
    end
  end
end

function mms.openIGM()
  if wait then return end
  if chars["player"] ~= nil then char_obj.stop("player") end
  mms.createMenu({ id = "igm", msg = "Inventory\nEquip\nStatus\nQuest Log\nOptions\nSave\nQuit", x = "left", y = "top", choices = 7 })
  state = gamestates.menu
  activemenu = "igm"
end

function mms.cycleChoice(dir)
  if activemenu == "cardgame" then
    if dir == "down" and chars[tostring(activecard)].ndir[4] ~= nil then
      activecard = chars[tostring(activecard)].ndir[4]
    elseif dir == "up" and chars[tostring(activecard)].ndir[1] ~= nil then
      activecard = chars[tostring(activecard)].ndir[1]
    elseif dir == "right" and chars[tostring(activecard)].ndir[3] ~= nil then
      activecard = chars[tostring(activecard)].ndir[3]
    elseif dir == "left" and chars[tostring(activecard)].ndir[2] ~= nil then
      activecard = chars[tostring(activecard)].ndir[2]
    end
  else
    if dir == "down" then
      mms.choice = mms.choice + 1
    elseif dir == "up" then
      mms.choice = mms.choice - 1
    end
    if mms.choice > mms.choices then
      mms.choice = 1
    elseif mms.choice <= 0 then
      mms.choice = mms.choices
    end
  end
end

function mms.backChoice()
  if activemenu == "cardgame" then
    card_obj.set(activecard, -1)
  elseif activemenu == "igm" then
    state = gamestates.game mms.destroyMsg("asafe")
  end
end

function mms.activateChoice()
  if activemenu == "cardgame" then
    card_obj.set(activecard, 1)
  elseif activemenu == "main" then
    if mms.choice == 1 then
      noplayer = false
      maps.moveTo("test")
      mms.destroyMsg("asafe")
      state = gamestates.game
    elseif mms.choice == 2 then
      maps.moveTo("nine_spread")
      mms.destroyMsg("asafe")
      state = gamestates.card_game
      activemenu = "cardgame"
    elseif mms.choice == 3 then
      
    elseif mms.choice == 4 then
      le.quit()
    end
  elseif activemenu == "main_opt" then
    if mms.choice == 1 then
      
    end
  elseif activemenu == "igm" then
    if mms.choice == 1 then -- Inventory
      
    elseif mms.choice == 2 then -- Equip
      
    elseif mms.choice == 3 then -- Status
      
    elseif mms.choice == 4 then -- Quest Log
      
    elseif mms.choice == 5 then -- Options
      
    elseif mms.choice == 6 then -- Save
    
    elseif mms.choice == 7 then -- Quit
      yes = le.quit
      no = function() mms.destroyMsg("all") wait = false state = gamestates.game end
      mms.createMsg({ msg = {{255, 0, 0, 255}, "Are you sure you want to quit?"}, follow = true })
      mms.createMenu({ id = "yn", msg = "Yes\nNo", choices = 2, oy = 64 })
      state = gamestates.menu
      activemenu = "yn"
    end
  elseif activemenu == "yn" then
    if mms.choice == 1 and yes ~= nil then
      yes()
    elseif mms.choice == 2 and no ~= nil then
      no()
    end
  end
end

function patternizeText(txt)
  if txt == nil then return false end
  local newTxt = txt
  --newTxt = string.gsub(newTxt, "(:name)", current_player.name)
  --newTxt = string.gsub(newTxt, "(:role)", current_player.role)
  return newTxt
end
